package com.its.op.service.its.database;

import com.its.op.dao.repository.its.database.TbCnctIntnRepository;
import com.its.op.dto.its.code.TbCmmnCdDto;
import com.its.op.dto.its.database.TbCnctIntnDto;
import com.its.op.entity.its.database.TbCnctIntn;
import com.its.op.global.CodeManager;
import com.its.op.service.its.code.TbCmmnCdService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

/**
 * 연계기관 관리 서비스
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class TbCnctIntnService {

    private final TbCnctIntnRepository repo;
    private final TbCmmnCdService cmmnCdService;

    // 데이터 1건 조회, 없으면 exception
    private TbCnctIntn requireOne(Long id) throws NoSuchElementException {
        Optional<TbCnctIntn> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbCnctIntnDto> findAll() {
        List<TbCnctIntnDto> result = new ArrayList<>();
        List<TbCnctIntn> data = this.repo.findAll();
        for (TbCnctIntn entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbCnctIntnDto findById(Long id) {
        TbCnctIntn entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbCnctIntnDto updateById(Long id, TbCnctIntnDto.TbCnctIntnUpdReq req) {
        TbCnctIntn entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbCnctIntnDto> mergeInfoList(List<TbCnctIntnDto.TbCnctIntnUpdReq> reqList) {
        List<TbCnctIntnDto> result = new ArrayList<>();
        for (TbCnctIntnDto.TbCnctIntnUpdReq req : reqList) {
            TbCnctIntn obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbCnctIntnDto mergeInfo(TbCnctIntnDto.TbCnctIntnUpdReq req) {
        TbCnctIntn obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbCnctIntnDto deleteById(Long id) {
        TbCnctIntn entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbCnctIntnDto> deleteByIds(List<Long> ids) {
        List<TbCnctIntnDto> result = new ArrayList<>();
        for (Long id : ids) {
            Optional<TbCnctIntn> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    // 연계기관 유형 코드 목록 조회
    @Transactional(readOnly = true)
    public List<TbCnctIntnDto.TbCnctType> findAllByCnctIntnType() {
        List<TbCnctIntnDto.TbCnctType> result = new ArrayList<>();
        List<TbCmmnCdDto> data = this.cmmnCdService.findAllByCmmnClsfCd(CodeManager.CNCT_INTN_TYPE_CD);
        if (data != null) {
	        data.forEach(obj -> {
	            if (("Y").equals(obj.getUseYn())) {
	                result.add(new TbCnctIntnDto.TbCnctType(obj));
	            }
	        });
	    }
        return result;
    }
}
